/*---------------------------------------------------------------------------*/
/* SCCS Information: %W%    %G% */
/*---------------------------------------------------------------------------*/
#include <stdlib.h>
#include "utilf.h"
#include "markers.h"
#include "surfaces.h"
#include "extra.h"
#include "global.h"
#include "mymalloc.h"

/*------------------------------------------------------------------*/
/*                 Computational arrays                             */
/*------------------------------------------------------------------*/
real2D p;
real2D u, v;
real2D S11, S22, S12;
real2D cc;
real2D sxp, syp, sxu, syu, sxv, syv, ap, au, av;
real2D rz1dr, rz2dr, rr1dz, rr2dz;
real2D a1, a2, a3, divs;
real2D work, work1;

/*------------------------------------------------------------------*/
/*                 Physical variables                               */
/*------------------------------------------------------------------*/
PhysStruct phys;
 
/*------------------------------------------------------------------*/
/*                 Numerical variables                              */
/*------------------------------------------------------------------*/
NumStruct num;

/*------------------------------------------------------------------*/
/*                 Output variables                                 */
/*------------------------------------------------------------------*/
OutStruct out;

/*------------------------------------------------------------------*/
/*                 Markers variables                                */
/*------------------------------------------------------------------*/
interface *interfaces;
int Nint;
interface_cut cutp, cutu, cutv;


void initglobal()
{
  p = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  u = (real2D) mymalloc(sizeof(real), num.nx + 1, num.ny); 
  v = (real2D) mymalloc(sizeof(real), num.nx, num.ny + 1); 
  S11 = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  S22 = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  S12 = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 

  cc = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  sxp = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  syp = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  sxu = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  syu = (real2D) mymalloc(sizeof(real), num.nx + 1, num.ny); 
  sxv = (real2D) mymalloc(sizeof(real), num.nx, num.ny + 1);
  syv = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  ap = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  au = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  av = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 

  rz1dr = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  rz2dr = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  rr1dz = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  rr2dz = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  
  a1 = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  a2 = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  a3 = (real2D) mymalloc(sizeof(real), num.nx, num.ny); 
  divs = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  work = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
  work1 = (real2D) mymalloc(sizeof(real), num.nx, num.ny);
}






