/*----------------------------------------------------------------------------*/
/* SCCS Information: %W%    %G% */
/*----------------------------------------------------------------------------*/
#include "utilf.h"
#include "make_bc_periodic.h"

void bc_scalar_periodic(real2D u, int nx, int ny)
{
  int j; 
  for (j = 1; j <= ny; j++)
    {
      u[1][j] = u[nx - 1][j];
      u[nx][j] = u[2][j];
    }
}


void bc_vector_periodic(real2D u, real2D v, int nx, int ny)
{
  int j; 
  for (j = 1; j <= ny; j++)
    {
      u[1][j] = u[nx - 1][j];
      u[nx][j] = u[2][j];
      v[1][j] = v[nx - 1][j];
      v[nx][j] = v[2][j];
    }
}


void bc_tensor_periodic(real2D S11, real2D S22, real2D S12, 
			int nx, int ny)
{
  int j; 
  for (j = 1; j <= ny; j++)
    {
      S11[1][j] = S11[nx - 1][j];
      S11[nx][j] = S11[2][j];
      S22[1][j] = S22[nx - 1][j];
      S22[nx][j] = S22[2][j];
      S12[1][j] = S12[nx - 1][j];
      S12[nx][j] = S12[2][j];
    }
}
