/* --------------------------------------------------------------------- */
/* 
   SCCS information: %W% %G%
*/
/* --------------------------------------------------------------------- */

/*  These subroutines invert the pressure equation

  ON INPUT:
 
  nx by ny double arrays:
  ---------------------
  u:  initial right hand side (divergence field)
  p:  anything
  cc: concentrations or volume fractions of phase 1

  scalar parameters:
  ------------------
  n:      dimension of arrays

 ON OUTPUT:

  everything the same, except

  p:      contains the pressure 
*/

#ifndef MG_H
#define MG_H

#define NGERROR		-1
#define NXERROR		-2
#define NYERROR		-3
#define MEMERROR	-5


extern void relax(real2D p, real2D rhs, real2D ap,
		  real2D c0, real2D c1, real2D c2, real2D c3, real2D c4,
		  int nx, int ny);

extern void resid(real2D res, real2D p, real2D rhs, real2D ap, 
		  real2D c0, real2D c1, real2D c2, real2D c3, real2D c4,
		  int nx, int ny);

extern int computeng(int n1, int n2);

extern int initpressure(int n1, int n2, int ng);

extern int mgsolve(real2D u, real2D p, real2D ap,
	           real2D c0, real2D c1, real2D c2, real2D c3, real2D c4,
	           interface in, real lredis, real maxdiv,
	           int n1, int n2, int ng) ;

extern void mgvcycle(int n, int nx, int ny, int npre, int npost);

#endif

