/*----------------------------------------------------------------------------*/
/* SCCS Information: %W%    %G% */
/*----------------------------------------------------------------------------*/
#ifndef MOMENTUM_H
#define MOMENTUM_H

extern void momentum(real2D u, real2D v,
		     real2D cu, real2D cv, real2D ap, real2D av,
		     real2D sxu, real2D syu, real2D sxv, real2D syv,	      
		     interface in, interface_cut cutu, interface_cut cutv,
		     real2D rz1dr, real2D rz2dr, real2D rr1dz, real2D rr2dz,
		     real2D w1,
		     real2D S11, real2D S22, real2D S12,
		     real2D w2,
		     real visliq,
		     real gx, real gy,
		     real tau,
		     int nx, int ny);

extern void pressure(real2D u, real2D v, real2D p, 
		     real2D cu, real2D cv,
		     real2D ap, real2D av,
		     real2D sxp, real2D syp, 
		     real2D syu, real2D sxv,
		     real2D rz1dr, real2D rz2dr, real2D rr1dz, real2D rr2dz,
		     real2D div, real2D tmp,
		     real2D c0, real2D c1, real2D c2, real2D c3, real2D c4,
		     interface in, real lredis,
		     int *ncycle, int npre, int npost, real maxdiv,
		     int nx, int ny, int ng);

void coli(real2D sxp, real2D syp, 
	  real2D syu, real2D sxv,
	  real2D cu, real2D cv, real2D ap, real2D av,
	  real2D rz1dr, real2D rz2dr,
	  real2D rr1dz, real2D rr2dz,
	  real2D c0, real2D c1, real2D c2, real2D c3, real2D c4,
	  int nx, int ny, real scale);

extern void adaptative(real2D u, real2D v, real2D p,
		       real *tau,
		       int ncycle, int nx, int ny);

extern void rescale(real2D u, real2D v, real2D p, 
                    real tscale,
                    int nx, int ny);

extern void divergence(real2D u, real2D v, real2D ap,
		       real2D sxp, real2D syp, 
		       real2D rz1dr, real2D rz2dr,
		       real2D rr1dz, real2D rr2dz,
		       real2D div, int nx, int ny);

#endif


