
/* SCCS INFORMATION: filename - geascii.c, SCCS delta - 1.2, date - 7/22/94 */

/* ********************************************************************* */
/* HEADER FILES                                                          */
/* ********************************************************************* */

/* --------------------------------------------------------------------- */
/* ANSI C header files                                                   */
/* --------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* --------------------------------------------------------------------- */
/* PLACEMENT SIMULATOR header files                                      */
/* --------------------------------------------------------------------- */

#include <gedefine.h>
#include <geerror.h>

/* ********************************************************************* */
/* USER FUNCTIONS                                                        */
/* ********************************************************************* */

/* --------------------------------------------------------------------- */
/* This function compares each line of the file                          */
/* with the argument string from either the beginning (start = TRUE) or  */
/* from the current position (start = FALSE). When successful            */
/* the number of lines is counted and RETURNED. If no such string exists */
/* an ERROR is raised, and the program is exited.                        */
/* --------------------------------------------------------------------- */

int GEffind_string(FILE *fpt,char *string,BOOLEAN start)
{
  int n = 0;
  STR line;

  char *errstr=" - Can't find this character string in scanned file.";

  if (start)
    rewind(fpt);

  while (fgets(line,STR_SIZE,fpt) != NULL)
    {
      n++;

      if (strstr(line,string) != NULL)
	return n;
    }

  strcat(string,errstr);
  GEstandard_error(string);

  return 0;
} /* end GEffind_string() */

/* --------------------------------------------------------------------- */
/* This function returns the number of data lines (n)                    */
/* between the header string and the string ":: end ::"                  */
/* --------------------------------------------------------------------- */

int GEcount_data_lines(FILE *fpt,char *string)
{
  GEffind_string(fpt,string,TRUE);

  return GEffind_string(fpt,":: end ::",FALSE);

} /* end GEcount_data_lines() */

/* --------------------------------------------------------------------- */
/* This function is an overloading of fopen. Besides opening the file    */
/* it also sets its buffer to NULL so that each fprintf directly sends   */
/* the data to the file instead of the temporary buffer                  */
/* --------------------------------------------------------------------- */

FILE *GEfbopen(char *filename,
	     char *mode)
{
  /* local declarations */

  FILE *fpt;
  char *errstr=" - Can't open this file in GEfbopen()";

  /* begin */

  if ((fpt=fopen(filename,mode)) EQUALS NULL)
    GEstandard_error(strcat(filename,errstr));

  setbuf(fpt,NULL);

  return fpt;

} /* end GEfbopen() */
