
/* SCCS INFORMATION: filename - geascii.h, SCCS delta - 1.2, date - 7/22/94 */

/* TOOLS TO MANAGE ASCII FILES */

/* ---------------------------------------------- */

/*  This function compares each line of the file                          
    with the argument string from either the 
    beginning (start = TRUE) or from the current 
    position (start = FALSE). When successful the 
    number of lines is counted and RETURNED. If no 
    such string exists an ERROR is raised, and the 
    program is exited.  */

int GEffind_string(FILE *fpt,
		   char *string,
		   BOOLEAN start);

/* - fpt : pointer to the scanned file
   - string : pointer to the sought string
   - start : flag to specify search from
     beginning of file */

/* ---------------------------------------------- */

/*  This function returns the number of data lines (n)                    
 between the header string and the string ":: end ::" */

int GEcount_data_lines(FILE *fpt,
		       char *string);

/* - fpt : pointer to the scanned file
   - string : pointer to the header string */

/* ---------------------------------------------- */

/*  This function is an overloading of fopen. Besides 
    opening the file it also sets its buffer to NULL 
    so that each fprintf directly sends the data to 
    the file instead of the temporary buffer */

FILE *GEfbopen(char *filename,
	       char *mode);

/* - filename : pointer to the name of the file
   - mode : opening mode (same as for fopen()) */


/* ---------------------------------------------- */
