
/* SCCS INFORMATION: filename - gedefine.h, SCCS delta - 1.2, date - 7/22/94 */


/* define some universal constants */

#define GRAVITY 9.8118186
#define PI 3.141592654
#define YOUNG 2.0786E+11
#define POISSON 0.3

/* cancel any definitions for FALSE, TRUE (VAX C compatibility) */

#undef FALSE
#undef TRUE

/* define boolean type */

typedef enum{FALSE=0,TRUE=1} BOOLEAN;

/* define equality to remove error problem */

#define EQUALS == 

/* define logical OR and logical AND */

#define OR ||

#define AND &&

/* maximum string length and string type */

#define STR_SIZE 100

typedef char STR[STR_SIZE];

/* define the real dynamic array type
   with range [first..last] (in ADA speak) */

typedef struct
{
  STR *pt;
  int  first;
  int  last;
} DYN_STR_VECTOR;

/* define the real dynamic array type
   with range [first..last] (in ADA speak) */

typedef struct
{
  double *pt;
  int  first;
  int  last;
} DYN_double_VECTOR;

/* define the real dynamic array type
   with range [first1..last1,first2..last2] (in ADA speak) */

typedef struct
{
  double **pt;
  int first1;
  int last1;
  int first2;
  int last2;
} DYN_double_MATRIX;

/* define the integer dynamic array type
   with range [first..last] (in ADA speak) */

typedef struct
{
  int *pt;
  int  first;
  int  last;
} DYN_INT_VECTOR;

/* define the integer dynamic array type
   with range [first1..last1,first2..last2] (in ADA speak) */

typedef struct
{
  int **pt;
  int first1;
  int last1;
  int first2;
  int last2;
} DYN_INT_MATRIX;

/* define the dynamic tabulated (x,y) pair */

typedef struct
{
  DYN_double_VECTOR xtable;
  DYN_double_VECTOR ytable;
} DYN_XY;

/* define functions */

#define MAX(a,b) ( ( (a) > (b) ) ? (a) : (b) )

#define MIN(a,b) ( ( (a) > (b) ) ? (b) : (a) )

#define EQUALS_ZERO(x) ( (x<=1.e-5 && x>=-1.e-5) ? 1 : 0 )

/* define math functions
   
   which interface between 
   double type (double or float) 
   and double type found in <math.h> */

#include <math.h>
