#ifndef READSIUNITS_H
#define READSIUNITS_H

/* Read a string with the format "nameofvariable=variablevalue" and
   return the number of occurences of the variable in the file and the
   "variablevalue" for the last occurence
*/  
extern int stringread(const char *string, char *val, FILE *fptr);

/* Read a string with the format "nameofvariable=variablevalue units"
   from a file pointed by fptr
   and try to convert it to SI units
   if units is omitted no conversion is done
   returns the number of occurences of the variable in the file
   and its converted value (double) for the last occurence
*/
extern int doublereadSI(const char *varname, double *val, FILE *fptr);

extern int floatreadSI(const char *varname, float *val, FILE *fptr);

/* Same as stringread but convert the value to integer using atoi
   C function */
extern int intread(const char *varname, int *val, FILE *fptr);


#endif
