#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <readSIunits.h>


int stringread(const char *string, char *val, FILE *fptr)
{
  char s[256], *s1;
  int i, j, found = 0, l;
  
  rewind(fptr);
  while (fgets(s, 256, fptr) != NULL) {
    i = 0;
    while (s[i] == ' ' || s[i] == '	')
      i++;
    j = 0;
    while (s[i] != '\0')
      s[j++] = s[i++];
    s[j] = '\0';
    if (s[0] != '#') {
      s1 = s; l = 0;
      while (*s1 != '\0' && *s1++ != '=')
	l++;
      if (*s1 != '\0' && strlen(string) == l &&
	  !strncmp(s, string, l)) {
	i = 0;
	while(s1[i] == ' ' || s1[i] == '	')
	  i++;
	j = 0;
	while(s1[i] != '\0')
	  s1[j++] = s1[i++];
	s1[j--] = '\0';
	while((j >= 0) && 
	      (s1[j] == ' ' || s1[j] == '	' || s1[j] == '\n'))
	  s1[j--] = '\0';
	strcpy(val, s1);
	found++;
      }
    }
  }
  return found;
}


int doublereadSI(const char *varname, double *val, FILE *fptr)
{
  char sval[256], *sunit;
  int nb;
  
  if ((nb = stringread(varname, sval, fptr)) == 0)
    return 0;
  
  sunit = strtok(sval, " 	");
  if (sunit == NULL || sunit == sval)
    /*  No units found: value suppose to be in SI units  */
    *val = atof(sval);    
  else {
    /*  Units found: try to convert in SI units */
    printf("%s: units: %s\n", sval, sunit);
  }
  return nb;
}


int floatreadSI(const char *varname, float *val, FILE *fptr)
{
  char sval[256], *sunit;
  int nb;
  
  if ((nb = stringread(varname, sval, fptr)) == 0)
    return 0;
  
  sunit = strtok(sval, " 	");
  if (sunit == NULL || sunit == sval)
    /*  No units found: value suppose to be in SI units  */
    *val = atof(sval);    
  else {
    /*  Units found: try to convert in SI units */    
    printf("%s: units: %s\n", sval, sunit);
  }
  return nb;
}


int intread(const char *varname, int *val, FILE *fptr)
{
  char sval[256];
  int nb;
  
  if ((nb = stringread(varname, sval, fptr)) == 0)
    return 0;
  *val = atoi(sval);
  return nb;
}




