#include "utilf.h"
#include "polynomial.h"

real polyeval(real *p, int n, real x)
{
  real val = p[n-1];
  int i;
  for (i = n - 2; i >= 0; i--)
    val = x*val + p[i];
  return val;
}

void polyderiv(real *p, int n, real *pderiv)
{
  int i;
  for (i = 0; i < n - 1; i++)
    pderiv[i] = (real)(i + 1)*p[i+1];
}

void polyint(real *p, int n, real *pint)
{
  int i;
  pint[0] = 0.0;
  for (i = 0; i < n; i++)
    pint[i+1] = p[i]/(real)(i + 1);
}

void polymul(real *p1, int n1, real *p2, int n2, real *pmul)
{
  int i, j;

  for (i = 0; i < n1 + n2 - 1; i++)
    pmul[i] = 0.0;
  for (i = 0; i < n1; i++)
    for (j = 0; j < n2; j++)
      pmul[i + j] += p1[i]*p2[j];
}

void polyprint(real *p, int n)
{
  int i;
  printf("[ ");
  for (i = 0; i < n; i++)
    printf("%g ", p[i]);
  printf("]");
}





