/*------------------------------------------------------------------*/
/* SCCS Information: %W%    %G% */
/*------------------------------------------------------------------*/
#include <malloc.h>
#include "utilf.h"
#include "markers.h"
#include "save.h"
#include "inout.h"


void iniget(real2D u, real2D v, real2D c, real2D p,
	    interface **inter,
	    int *nin,
	    real *po, real *vo, real *t, real *pext,
	    real *tau, int nx, int ny, char *fname)
{
  int i;
  FILE *fptr;
  
  if (!(fptr = fopen(fname, "rb"))) {
    printf("iniget: can not open file `%s'\n", fname);
    exit(1);
  }
  fread(&(u[1][1]), sizeof(real), (nx + 1) * ny, fptr);
  fread(&(v[1][1]), sizeof(real), nx * (ny + 1), fptr);
  fread(&(c[1][1]), sizeof(real), nx * ny, fptr);     
  fread(&(p[1][1]), sizeof(real), nx * ny, fptr);
  fread(nin, sizeof(int), 1, fptr);
  *inter = (interface *)malloc(sizeof(interface) * *nin);
  for (i = 0; i < *nin; i++) {
    fread(&((*inter)[i].n), sizeof(int), 1, fptr);
    printf("%d: %d markers\n", i, (*inter)[i].n);
    (*inter)[i].x = (real *)malloc((*inter)[i].n * sizeof(real));
    (*inter)[i].y = (real *)malloc((*inter)[i].n * sizeof(real));
    (*inter)[i].t = (real *)malloc((*inter)[i].n * sizeof(real));
    (*inter)[i].spx = (polynom3 *)malloc(((*inter)[i].n - 1) 
					 * sizeof(polynom3));
    (*inter)[i].spy = (polynom3 *)malloc(((*inter)[i].n - 1) 
					 * sizeof(polynom3));
    fread((*inter)[i].x, sizeof(real), (*inter)[i].n, fptr);
    fread((*inter)[i].y, sizeof(real), (*inter)[i].n, fptr);
    fread(&((*inter[i]).bc), sizeof(char), 1, fptr);
  }
  fread(po, sizeof(real), 1, fptr);
  fread(vo, sizeof(real), 1, fptr);
  fread(t, sizeof(real), 1, fptr);
  fread(pext, sizeof(real), 1, fptr);
  fread(tau, sizeof(real), 1, fptr);
  fclose(fptr);
}


void save(real2D u, real2D v, real2D c, real2D p,
	  interface *inter, int nin,
	  real po, real vo, real t, real pext,
	  real tau, int nx, int ny, char *fname)
{
  int i;
  FILE *fptr;
  
  if (!(fptr = fopen(fname, "wb"))) {
    printf("save: can not open file `%s'\n", fname);
    exit(1);
  }
  fwrite(&(u[1][1]), sizeof(real), (nx + 1) * ny, fptr);
  fwrite(&(v[1][1]), sizeof(real), nx * (ny + 1), fptr);
  fwrite(&(c[1][1]), sizeof(real), nx * ny, fptr);
  fwrite(&(p[1][1]), sizeof(real), nx * ny, fptr);
  fwrite(&nin, sizeof(int), 1, fptr);
  for (i = 0; i < nin; i++) {
    fwrite(&(inter[i].n), sizeof(int), 1, fptr);
    fwrite(inter[i].x, sizeof(real), inter[i].n, fptr);
    fwrite(inter[i].y, sizeof(real), inter[i].n, fptr);
    fwrite(&(inter[i].bc), sizeof(char), 1, fptr);    
  }
  fwrite(&po, sizeof(real), 1, fptr);
  fwrite(&vo, sizeof(real), 1, fptr);
  fwrite(&t, sizeof(real), 1, fptr);
  fwrite(&pext, sizeof(real), 1, fptr);
  fwrite(&tau, sizeof(real), 1, fptr);
  fclose(fptr);
}






