#include "utilf.h"
#include "stypes.h"
#include "stresses.h"


void viscous_tensor(real2D u, real2D v,
		    real2D S11, real2D S22, real2D S12,
		    real visliq, real tau,
		    int nx, int ny)
{
  int i, j;
  real h = 1.0 / (nx - 2);
  
  visliq *= tau / (h * h);
  for (i = 1; i <= nx; i++)
    for (j = 2; j < ny; j++)
      S11[i][j] = 2.*visliq*(u[i+1][j] - u[i][j]);
  for (i = 2; i < nx; i++)
    for (j = 2; j <= ny; j++)
      S22[i][j] = 2.*visliq*(v[i][j+1] - v[i][j]);
  for (i = 2; i <= nx; i++)
    for (j = 2; j <= ny; j++)
      S12[i][j] = visliq*(u[i][j] - u[i][j-1] + v[i][j] - v[i-1][j]);
}













