/*----------------------------------------------------------------------------*/
/* SCCS Information: %W%    %G% */
/*----------------------------------------------------------------------------*/
#include <stdlib.h>

#ifndef STYPES_H
#define STYPES_H

/*------------------------------------------------------------------*/
/*                 Physical variables                               */
/*------------------------------------------------------------------*/
typedef struct {
  real xvel, yvel, visliq, sigma, t;
  real po, vo, gamma, pe, p_inf, omega, pext;
  real gx, gy;
  int eq;
} PhysStruct;
typedef PhysStruct *PPhysStruct;

/*------------------------------------------------------------------*/
/*                 Numerical variables                              */
/*------------------------------------------------------------------*/
typedef struct {
  real tau, tausi, du, dp;
  real lredis;
  int ng, nx, ny, cycles, npre, npost, tmax;
  real maxdiv;
} NumStruct;
typedef NumStruct *PNumStruct;

/*------------------------------------------------------------------*/
/*                 Output variables                                 */
/*------------------------------------------------------------------*/
typedef struct {
  int tprint, tsave, txplot, tmark;
} OutStruct;
typedef OutStruct *POutStruct;

#endif
