typedef struct {
  real t;
  int ip, type, coord;
} listinter;

typedef struct {
  listinter *list;
  real xo, yo;
  int ncut;
} interface_cut;

extern real interface_inside(interface in, real x, real y);
extern void cut_interface(interface in, interface_cut *cut, real xo, real yo);
extern void interface_cut_write(interface in, interface_cut cut, char *file);
extern void interface_surfaces(interface in, interface_cut cut,
			       real2D sx, real2D sy, real2D a, real2D c,
			       real2D wa, real2D wc,
			       int nx, int ny);
extern void sx_fill(real2D sx, real2D a, real xo, real yo, 
		    interface in, int nx, int ny);
extern void sy_fill(real2D sy, real2D a, real xo, real yo, 
		    interface in, int nx, int ny);
extern void sx_write(real2D sx, real xo, real yo, int nx, int ny, FILE *fptr);
extern void sy_write(real2D sy, real xo, real yo, int nx, int ny, FILE *fptr);
extern void interface_rzdr(interface in, interface_cut cut, real za,
			   real2D rzdr,
			   int nx, int ny);
extern void interface_rrdz(interface in, interface_cut cut, real ra,
			   real2D rrdz,
			   int nx, int ny);





