/* Defines for the Xfig format version 2.1 */
#define XFIG_NOT_USED -1

#define XFIG_DEFAULT -1
#define XFIG_BLACK 0
#define XFIG_BLUE 1
#define XFIG_GREEN 2
#define XFIG_CYAN 3
#define XFIG_RED 4
#define XFIG_MAGENTA 5
#define XFIG_YELLOW 6
#define XFIG_WHITE 7

#define XFIG_NOT_FILLED 0
#define XFIG_WHITE_FILLED 1
#define XFIG_BLACK_FILLED 21

#define XFIG_SOLID 0
#define XFIG_DASHED 1
#define XFIG_DOTTED 2

#define XFIG_COMPOUND 6

#define XFIG_POLYLINE 2
#define XFIG_POLY_TYPE 1
#define XFIG_BOX_TYPE 2
#define XFIG_POLYGON_TYPE 3
#define XFIG_ARC_BOX_TYPE 4
#define XFIG_EPS_BOX_TYPE 5
#define XFIG_ELLIPSE_TYPE 1
#define XFIG_TEXT_TYPE 4
#define XFIG_END_POLY 9999

#define XFIG_LEFT 0
#define XFIG_RIGHT 2
#define XFIG_CENTER 1

#define XFIG_DEFAULT -1
#define XFIG_TIMES_ROMAN 0
#define XFIG_TIMES_ITALIC 1
#define XFIG_TIMES_BOLD 2
#define XFIG_TIMES_BOLD_ITALIC 3

extern void XfigStartCompound(FILE *fptr, int ix1, int iy1, int ix2, int iy2);

extern void XfigEndCompound(FILE *fptr);

extern void XfigPolyLine(FILE *fptr, int *x, int *y, int npoints, 
			 int linestyle, int thickness, int color);

extern void XfigVector(FILE *fptr, int x, int y, int fx, int fy, 
		       int linestyle, int thickness, int color);

extern void XfigLine(FILE *fptr, int x, int y, int x1, int y1, 
		     int linestyle, int thickness, int color);

extern void XfigBox(FILE *fptr, int ix1, int iy1, int ix2, int iy2,
		    int linestyle, int thickness, int color);

extern void XfigCircle(FILE *fptr, int x, int y, int radius,
		       int linestyle, int thickness, int color);

extern void XfigText(FILE *fptr, int x, int y, int sub_type, 
		     int font, int font_size,
		     int color, float angle, char *text);
